#pragma once
//==========================================================================
// Util.h
//   ֐NX
//==========================================================================

//------------------------------------------------------------
// tstring
//   _UNICODE / _MBCS p
//------------------------------------------------------------

#ifdef _UNICODE
	typedef wstring tstring;
#else
	typedef  string tstring;
#endif

//------------------------------------------------------------
// to_bool
//   0Ɣr\Ȓlboolɕϊ
//------------------------------------------------------------

template<typename T>
  inline bool to_bool( T v ) { return v != 0; }

//------------------------------------------------------------
// lengthof
//   z̒
//------------------------------------------------------------

namespace lenghtof_detail {
  template<int N> struct sized_type { typedef char (&type)[N]; };
  template<typename T,int N> typename sized_type<N>::type lengthof_impl(T (&x)[N]);
}

#define lengthof(arr) (sizeof(lenghtof_detail::lengthof_impl(arr)))

//------------------------------------------------------------
// current_module
//   ݂̎st@C(.exe)̃W[nh擾
//------------------------------------------------------------

inline HINSTANCE current_module()
  { return ::GetModuleHandle(NULL); }

//------------------------------------------------------------
// load_string
// load_icon
// load_menu
//   Win32\[X̃[h
//------------------------------------------------------------

inline tstring load_string( UINT id )
{
	vector<TCHAR> buf( 256 );
	while( "the buffer is too small" )
	{
		size_t siz = ::LoadString( current_module(), id, &buf[0], buf.size() );
		if( siz < buf.size() )
		{
			buf.resize(siz);
			break;
		}
	}
	return tstring( buf.begin(), buf.end() );
}

inline HICON load_icon( UINT id )
{
	return ::LoadIcon( current_module(), MAKEINTRESOURCE(id) );
}

inline HMENU load_menu( UINT id )
{
	return ::LoadMenu( current_module(), MAKEINTRESOURCE(id) );
}

//------------------------------------------------------------
// alert
//   fobOpBbZ[W{bNX\
//------------------------------------------------------------

inline void alert( const tstring& str )
  { ::MessageBox( NULL, str.c_str(), NULL, MB_OK ); }

//------------------------------------------------------------
// console_ostream
//   fobOpBWin32R\[Ăɏo
//------------------------------------------------------------

class console_ostream
	: public ostream
{
	class console_ostreambuf
		: public std::basic_streambuf<char>
	{
		typedef std::char_traits<char> traits;
		virtual int_type overflow( int_type c = traits::eof() )
		{
			if( !traits::eq_int_type(c, traits::eof()) )
			{
				char ch = c;
				xsputn( &ch, 1 );
			}
			return c;
		}
		virtual std::streamsize xsputn( const char* s, std::streamsize n )
		{
			DWORD written;
			::WriteFile( ::GetStdHandle(STD_OUTPUT_HANDLE), s, n, &written, NULL );
			return n;
		}
	public:
		 console_ostreambuf() { ::AllocConsole(); }
		~console_ostreambuf() { ::FreeConsole(); }
	};

public:
	console_ostream() : ostream( new console_ostreambuf ) {}
};

//------------------------------------------------------------
// deny_multi_boot
//   AvP[VN̂֎~
//------------------------------------------------------------

class deny_multi_boot
	: noncopyable
{
	HANDLE mutex;

public:
	class exception {};

	deny_multi_boot( const tstring& name )
		: mutex( ::CreateMutex(NULL, FALSE, name.c_str()) )
	{
		if( WAIT_OBJECT_0 != ::WaitForSingleObject(mutex, 0) )
		{
			::CloseHandle( mutex );
			throw exception();
		}
	}

	~deny_multi_boot()
	{
		::ReleaseMutex( mutex );
		::CloseHandle( mutex );
	}
};

//------------------------------------------------------------
// msg_receiver
//   bZ[WM邽ߕsWindowĂɂ傲ɂ
//------------------------------------------------------------

class msg_receiver
	: noncopyable
{
protected:
	// WS_EX_TOOLWINDOW ɂAAlt+TabƂ^XNo[Ƃ
	// łĂȂBWindowIȂ̂B
	msg_receiver( const TCHAR* dummyWndName = TEXT("hidden_window") )
		: eventHandlerWnd( ::CreateWindowEx(
			WS_EX_TOOLWINDOW, getWndClass(), dummyWndName, 0,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			NULL, NULL, current_module(), this ) ) {
				int x = 8;
			}
	~msg_receiver()
		{ ::DestroyWindow( eventHandlerWnd ); }

	void postMessage( UINT msg, WPARAM wp=0, LPARAM lp=0 )
		{ ::PostMessage( eventHandlerWnd, msg, wp, lp ); }

	HWND wnd_handle() const
		{ return eventHandlerWnd; }

	virtual LRESULT on_message( UINT msg, WPARAM wp, LPARAM lp )
		{ return ::DefWindowProc( eventHandlerWnd, msg, wp, lp ); }

private:
	static const TCHAR* getWndClass()
	{
		static WNDCLASSEX wc;
		if( wc.lpszClassName == NULL )
		{
			wc.cbSize        = sizeof(wc);
			wc.lpszClassName = TEXT("kilib_std_hidden_window");
			wc.hInstance     = current_module();
			wc.lpfnWndProc   = &WndProc;
			::RegisterClassEx( &wc );
		}
		return wc.lpszClassName;
	}

	static LRESULT CALLBACK WndProc( HWND wnd, UINT msg, WPARAM wp, LPARAM lp )
	{
		// USERDATA  this |C^Ƃ
		if( msg == WM_CREATE )
			::SetWindowLongPtr(
				wnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(
					reinterpret_cast<CREATESTRUCT*>(lp)->lpCreateParams)
			);

		// |C^oăR}h]
		LONG_PTR ptr = ::GetWindowLongPtr(wnd, GWLP_USERDATA);
		if( ptr == 0 )
			return ::DefWindowProc( wnd, msg, wp, lp );
		return reinterpret_cast<msg_receiver*>(ptr)->on_message( msg, wp, lp );
	}

	const HWND eventHandlerWnd;
};

//------------------------------------------------------------
// move_center_relative_to
//------------------------------------------------------------

inline void move_center_relative_to( HWND wnd, HWND rel=NULL )
{
	// ̃TCY擾
	RECT rc, pr;
	::GetWindowRect( wnd, &rc );

	// ëʒuAȂ͑Sʂ̈ʒu擾
	if( rel != NULL )
		::GetWindowRect( rel, &pr );
	else
		::SystemParametersInfo( SPI_GETWORKAREA, 0, &pr, 0 );

	// Ɉړ
	::SetWindowPos( wnd, 0,
		pr.left + ( (pr.right-pr.left)-(rc.right-rc.left) )/2,
		pr.top  + ( (pr.bottom-pr.top)-(rc.bottom-rc.top) )/2,
		0, 0, SWP_NOSIZE|SWP_NOZORDER );
}

