//==========================================================================
// DirectX.h
//   DirectX Graphics ܂̏
//==========================================================================

#include "StdAfx.h"
#include "Util.h"
#include "DirectX.h"
#pragma comment( lib, "d3dx8.lib" )

DirectXManager::DirectXManager()
	: d3d_dll       ( ::LoadLibrary(TEXT("d3d8.dll")) )
	, direct3D      ( NULL )
	, direct3DDevice( NULL )
{
	if( d3d_dll != NULL )
		if( FARPROC proc = ::GetProcAddress(d3d_dll, "Direct3DCreate8") )
			direct3D = reinterpret_cast<IDirect3D8* (WINAPI*)(UINT)>(proc)(D3D_SDK_VERSION);
}

DirectXManager::~DirectXManager()
{
	if( direct3DDevice != NULL ) direct3DDevice->Release();
	if( direct3D != NULL )       direct3D->Release();
	if( d3d_dll != NULL )        ::FreeLibrary( d3d_dll );
}

IDirect3DDevice8* DirectXManager::setUpDevice( HWND wnd )
{
	// ݂̉ʃ[h擾
	D3DDISPLAYMODE d3ddm;
	direct3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm );

	// p[^ݒ
	D3DPRESENT_PARAMETERS d3dpp = {0};
    d3dpp.Windowed          = true;
    d3dpp.SwapEffect        = D3DSWAPEFFECT_COPY;
	d3dpp.BackBufferFormat  = d3ddm.Format;

	RECT rc;
	::GetWindowRect( wnd, &rc );
	SIZE sz = {rc.right-rc.left, rc.bottom-rc.top};

	if( direct3DDevice == NULL )
	{
		// foCXIuWFNg쐬iHALHEL̏Ŏj
		if( FAILED(direct3D->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL, wnd,
		                                  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
		                                  &d3dpp, &direct3DDevice)) )
			if( FAILED(direct3D->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_REF, wnd,
											D3DCREATE_SOFTWARE_VERTEXPROCESSING,
											&d3dpp, &direct3DDevice)) )
				return NULL;
	}
	else if( currentBufferSize.cx!=sz.cx || currentBufferSize.cy!=sz.cy )
	{
		// TCYύXĂݒ胊Zbg
		// Note: CreateDevicêƓXbhĂ΂ȂƎsB
		if( FAILED(direct3DDevice->Reset(&d3dpp)) )
			direct3DDevice->Release(), direct3DDevice=NULL;
	}

	currentBufferSize = sz;
	return direct3DDevice;
}

IDirect3DTexture8* DirectXManager::loadTexture( const tstring& fileName )
{
	//D3DPOOL_MANAGED
	IDirect3DTexture8* tex = NULL;
	if( direct3DDevice != NULL )
	{
		// Reset\bhĝMANAGEDōĂ
		//::D3DXCreateTextureFromFile( direct3DDevice, fileName.c_str(), &tex );
		::D3DXCreateTextureFromFileEx(
			direct3DDevice, fileName.c_str(),
			D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0,
			D3DFMT_UNKNOWN,
			D3DPOOL_MANAGED,
			D3DX_DEFAULT, D3DX_DEFAULT, 0xFF000000, NULL, NULL,
			&tex );

	}
	return tex;
}

